package pep;

import java.util.Random; import static pep.Main.nTargets;

/**This Attention class controls the attentional system.*/
public class Attention {
 /**deflection of attention*/ private double deflect;
 /**number generator*/        private Random rnd = new Random();
 /**attention array*/         private double targSearch[];
 /**attention input*/         private double in[];
 /**decay rate*/              private double decay = .01;

 /**Creates a new Attention node.*/
 public Attention(){
  deflect = 0;
  targSearch = new double[nTargets];
  in = new double[nTargets];
 }

 /**Adjusts the distracter signal strength randomly (can be lesioned).
  * @param dSigTrend Current value of signal.
  * @param dSignal Baseline value of signal.
  * @return New signal strength.*/
 public double wander(double dSigTrend,double dSignal){
  // <--insert asterisk between slashes to lesion attentional wandering
  double random = rnd.nextGaussian()*.4;
  if(random<-1) random=-1;
  else if(random>1) random = 1;
  deflect = deflect*.95+random*.05;
  dSigTrend = (dSigTrend*.9) + (dSignal*.1) + deflect;//*/
  return dSigTrend;
 }

 /**Increments input for target memory search strength.
  * @param prep Incoming goal activation.*/
 public void prepAttention(int index,double prep){
  if(prep>1) in[index] += 1;
  else if(prep>0) in[index] += prep;
 }

 /**Updates target search strengths with logistic function.*/
 public void updateGoal(){
  for(int x=0; x<nTargets; x++){
   in[x] = (1 / (1 + Math.exp(-((in[x]*8)-4))));
   targSearch[x] = targSearch[x]*(1-decay) + in[x]*decay;
   in[x] = .525;
  }
 }

 /**Get target search strength.
  * @param index Stimulus number.*/
 public double directedSearch(int index){
  return targSearch[index];
 }
}