package pep;

import java.io.*; import java.util.*;
import static pep.Main.nSubjects; import static pep.Main.multCue;
import static pep.Main.multTarg;  import static pep.Main.multDist;

/**This class concatenates individual data files into Dataset.txt. It also
 * encodes previous RTs, accuracy, and congruency. This class can be run
 * independently of the full model.*/
public class Concat {
 //----------VARIABLES--------------------------------------------------
 /**file name*/              static String fileName;
 /**number of variables*/    static int nVariables = Main.numPerVar.length;
 //---------------------------------------------------------------------
 /**response time*/          static int rt;
 /**previous response time*/ static int n1rt;
 /**accuracy*/               static int accuracy;
 /**previous accuracy*/      static int n1acc;
 /**distracter number*/      static int[] dist = new int[multDist];
 /**target number*/          static int[] targ = new int[multTarg];
 /**cue number*/             static int[] cue = new int[multCue];
 /**threshold at response*/  static double thresh;

 /**Get data from each participant.
  * @param args Not used*/
 public static void main(String[] args){
  for(int i=1; i<=nSubjects; i++){
   for(int c=0; c<multCue; c++) cue[c] = 999;
   for(int t=0; t<multTarg; t++) targ[t] = 999;
   for(int d=0; d<multDist; d++) dist[d] = 999;
   n1rt = 99999; n1acc = 999;
   getData(i);
  }
 }

 /**Gets the data for the participant and writes it to file.
  * @param i Participant number.*/
 public static void getData(int i){
  BufferedReader in = null;
  FileOutputStream out = null;
  PrintStream p = null;
  StringTokenizer tokenizer = null;
  try{
   fileName = "out"+i+".txt";
   in = new BufferedReader(new FileReader(fileName));
   if(i>1) out = new FileOutputStream("Dataset.txt", true);
   else out = new FileOutputStream("Dataset.txt");
   p = new PrintStream(out);
  }
  catch(Exception e){
   System.out.println("Error setting input and output streams.");
  }
  try{
   tokenizer = new StringTokenizer(in.readLine());
  }
  catch(Exception e){
   System.out.println("No data in file.");
  }
  String cong = ""; String n1cong = "";
  while(in!=null){
   try{
    p.print(tokenizer.nextToken()+"\t"); //subject
    p.print(tokenizer.nextToken()+"\t"); //response
    for(int c=0; c<multCue; c++){
     cue[c] = Integer.parseInt(tokenizer.nextToken());
     p.print(cue[c]+"\t");
    }
    for(int t=0; t<multTarg; t++){
     targ[t] = Integer.parseInt(tokenizer.nextToken());
     p.print(targ[t]+"\t");
    }
    for(int d=0; d<multDist; d++){
     dist[d] = Integer.parseInt(tokenizer.nextToken());
     p.print(dist[d]+"\t");
    }
    for(int n=0; n<nVariables; n++){
     if(n>0)
      p.print(tokenizer.nextToken()+"\t");
     else{
      cong = tokenizer.nextToken();
      p.print(""+cong+"\t");
     }
    }
    p.print(tokenizer.nextToken()+"\t"); //correct response
    rt = Integer.parseInt(tokenizer.nextToken());
    accuracy = Integer.parseInt(tokenizer.nextToken());
    p.print(rt+"\t"+accuracy+"\t");
    if(n1rt==99999) p.print(" \t \t"+n1cong);
    else p.print(n1rt+"\t"+n1acc+"\t"+n1cong);
    /*/ <- inset asterisk to ignore threshold at response
    p.println("\t"+tokenizer.nextToken());//*/p.println();
    n1rt = rt; n1acc = accuracy; n1cong = cong;
    String nextTrial = in.readLine();
    if(nextTrial.equals("END_OF_FILE")) in = null;
    else tokenizer = new StringTokenizer(nextTrial);
   }
   catch(NumberFormatException | IOException e3){
    in = null;
    System.out.println("No END_OF_FILE in data file.");
   }
  }
  try{
   p.close(); out.close();
  }
  catch(Exception e2){
   System.out.println("Error closing input and output streams");
  }
 }
}